/**
 * $Id: Bird.java,v 1.3 2009/01/25 14:05:49 oboehm Exp $
 *
 * Copyright (c) 2008 by Oliver Boehm
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express orimplied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 * (c)reated 22.01.2009 by oliver (ob@oasd.de)
 */
package patterntesting.sample.animal;

/**
 * @author <a href="boehm@javatux.de">oliver</a>
 * @since 22.01.2009
 * @version $Revision: 1.3 $
 */
public abstract class Bird {
    
    private final String name;
    
    /**
     * This is a bad example. Why? You should never call an abstract method
     * inside a constructor.
     * So, if you uncomment "sayHello()" it you'll get a warning message.
     * Also BirdTest.testDuck() will fail.
     */
    protected Bird(String name) {
        this.name = name;
        //sayHello();
    }
    
    public abstract void sayHello();

    /* (non-Javadoc)
     * @see java.lang.Object#toString()
     */
    @Override
    public String toString() {
        return this.getClass().getSimpleName() + " " + this.name;
    }

}

/**
 * $Log: Bird.java,v $
 * Revision 1.3  2009/01/25 14:05:49  oboehm
 * we don't expect an NPE here because
 * the problematic statement is commented out
 *
 * Revision 1.2  2009/01/24 22:26:19  oboehm
 * comment added
 *
 * Revision 1.1  2009/01/23 12:39:15  oboehm
 * example for bad use of abstract methods added
 *
 * $Source: /cvsroot/patterntesting/PatternTesting08/patterntesting-samples/src/main/java/patterntesting/sample/animal/Bird.java,v $
 */
